#include <stdio.h>
#include <ctype.h>
#include <string.h>

struct student  
{  
    char name[25];
    char rollnum[20];
    char branch[3];
    int age;
    int grp_num;
};  

int calculate_group_number(struct student stud){
    int val = 0;
    for(int id=0; id<strlen(stud.name); id++)   val += stud.name[id];
    val += stud.age;
    return val%4;
}

int main(){
    int num_students;
    scanf("%d",&num_students);

    struct student students[num_students];

    char curr_name[25], curr_rollbranch[25];
    char curr_rollnum[20], curr_branch[3];
    int curr_age;
    for(int stud_idx=0; stud_idx<num_students; stud_idx++){
        scanf("%s %s %d", curr_name, curr_rollbranch, &curr_age);
        strcpy(students[stud_idx].name, curr_name);
        students[stud_idx].name[strlen(curr_name)] = '\0';
        strncpy(students[stud_idx].rollnum, curr_rollbranch, strlen(curr_rollbranch)-2);
        students[stud_idx].rollnum[strlen(curr_rollbranch)-2] = '\0';
        strncpy(students[stud_idx].branch, curr_rollbranch+strlen(curr_rollbranch)-2, 2);
        students[stud_idx].branch[2] = '\0';
        students[stud_idx].branch[0] = toupper(students[stud_idx].branch[0]);
        students[stud_idx].branch[1] = toupper(students[stud_idx].branch[1]);
        students[stud_idx].age = curr_age;
        students[stud_idx].grp_num = calculate_group_number(students[stud_idx]);
    }
    // for(int stud_idx=0; stud_idx<num_students; stud_idx++){
    //     printf("%s, %s, %s, %d, %d\n", students[stud_idx].name, students[stud_idx].rollnum, students[stud_idx].branch, students[stud_idx].age, students[stud_idx].grp_num);
    // }

    char inp1;
    int check_grp_num;
    char check_branch[3];

    while (1){
        scanf("%c", &inp1);
        if (inp1 == 'e')    break;
        else if (inp1 == 'c'){
            scanf("%d", &check_grp_num);
            printf("  -> ");
            int count = 0;
            for(int stud_idx = 0; stud_idx <num_students; stud_idx++)
                if (students[stud_idx].grp_num == check_grp_num)    count++;
            printf("%d ", count);
            for(int stud_idx = 0; stud_idx <num_students; stud_idx++)
                if (students[stud_idx].grp_num == check_grp_num)    printf("%s ", students[stud_idx].name);
            printf("\n");
        }
        else if (inp1 >= '0' && inp1 <= '3'){
            int check_group = inp1 - '0';
            scanf("%s", check_branch);
            printf("  -> ");
            check_branch[0] = toupper(check_branch[0]);
            check_branch[1] = toupper(check_branch[1]);
            check_branch[2] = '\0';
            int count = 0;
            for(int stud_idx = 0; stud_idx <num_students; stud_idx++)
                if (check_group == students[stud_idx].grp_num && strcmp(students[stud_idx].branch, check_branch) == 0)   count++;
            if (count == 0) printf("-1\n");
            else{
                for(int stud_idx = 0; stud_idx <num_students; stud_idx++)
                    if (check_group == students[stud_idx].grp_num && strcmp(students[stud_idx].branch, check_branch) == 0)   printf("%s ", students[stud_idx].name);
                printf("\n");
            }
        }
    }
    


    return 0;
}
